# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

.decode_s_attribute <- function(corpus, s_attribute, registry) {
    .Call(`_RcppCWB_decode_s_attribute`, corpus, s_attribute, registry)
}

.get_count_vector <- function(corpus, p_attribute, registry) {
    .Call(`_RcppCWB_get_count_vector`, corpus, p_attribute, registry)
}

.get_region_matrix <- function(corpus, s_attribute, strucs, registry) {
    .Call(`_RcppCWB_get_region_matrix`, corpus, s_attribute, strucs, registry)
}

.get_cbow_matrix <- function(corpus, p_attribute, registry, matrix, window) {
    .Call(`_RcppCWB_get_cbow_matrix`, corpus, p_attribute, registry, matrix, window)
}

.region_matrix_to_ids <- function(corpus, p_attribute, registry, matrix) {
    .Call(`_RcppCWB_region_matrix_to_ids`, corpus, p_attribute, registry, matrix)
}

.ranges_to_cpos <- function(ranges) {
    .Call(`_RcppCWB_ranges_to_cpos`, ranges)
}

.ids_to_count_matrix <- function(ids) {
    .Call(`_RcppCWB_ids_to_count_matrix`, ids)
}

.region_matrix_to_count_matrix <- function(corpus, p_attribute, registry, matrix) {
    .Call(`_RcppCWB_region_matrix_to_count_matrix`, corpus, p_attribute, registry, matrix)
}

.region_matrix_context <- function(corpus, registry, region_matrix, p_attribute, s_attribute, boundary, left, right) {
    .Call(`_RcppCWB_region_matrix_context`, corpus, registry, region_matrix, p_attribute, s_attribute, boundary, left, right)
}

#' Get min and max strucs of s-attribute present in region
#' 
#' Look up the minimum and maximum struc of a s-attribute within a region,
#' including scenario of nested s-attributes. If there are no regions of the
#' s-attribute within the region, `NA` values are returned.
#' 
#' 
#' @param corpus ID of a CWB corpus.
#' @param registry Path of the registry directory. If `NULL` (default), value
#'   of environment variable 'CORPUS_REGISTRY' will be used.
#' @param s_attribute Name of structural attribute. The attribute may be
#'   nested.
#' @param region Vector with left and right corpus position of region.
#' @return Depending whether input is a vector (argument `region`) or a matrix
#' (argument `region_matrix`), a vector or a matrix.
#' @param region_matrix A two-column `matrix` with regions, left corpus
#'   positions in column 1, right corpus positions in column 2.
#' @rdname regions_to_strucs
region_matrix_to_struc_matrix <- function(corpus, s_attribute, region_matrix, registry = NULL) {
    .Call(`_RcppCWB_region_matrix_to_struc_matrix`, corpus, s_attribute, region_matrix, registry)
}

#' @rdname regions_to_strucs
region_to_strucs <- function(corpus, s_attribute, region, registry = NULL) {
    .Call(`_RcppCWB_region_to_strucs`, corpus, s_attribute, region, registry)
}

.cwb_version <- function() {
    .Call(`_RcppCWB_cwb_version`)
}

#' Get default p-attribute
#' 
#' Usually the default p-attribute will be "word". Use this function to avoid
#' a hard-coded solution. Extracts the default attribute defined in the CWB
#' source code.
#' 
#' @rdname p_attr_default
#' @return A length-one `character` vector.
#' @export
p_attr_default <- function() {
    .Call(`_RcppCWB_p_attr_default`)
}

#' @param corpus ID of a CWB corpus (length-one `character` vector).
#' @param s_attribute A structural attribute (length-one `character` vector).
#' @param registry Registry directory.
#' @rdname cl_rework
#' @export
s_attr <- function(corpus, s_attribute, registry) {
    .Call(`_RcppCWB_s_attr`, corpus, s_attribute, registry)
}

#' @param p_attribute A positional attribute (length-one `character` vector).
#' @rdname cl_rework
#' @export
p_attr <- function(corpus, p_attribute, registry) {
    .Call(`_RcppCWB_p_attr`, corpus, p_attribute, registry)
}

#' @param attribute Either a positional, or a structural attribute.
#' @param attribute_type Either "p" (positional attribute) or "s" (structural attribute).
#' @rdname cl_functions
attribute_size <- function(corpus, attribute, attribute_type, registry) {
    .Call(`_RcppCWB_attribute_size`, corpus, attribute, attribute_type, registry)
}

#' @param p_attr A `externalptr` referencing a p-attribute.
#' @rdname cl_rework
#' @export
p_attr_size <- function(p_attr) {
    .Call(`_RcppCWB_p_attr_size`, p_attr)
}

#' @param s_attr A `externalptr` referencing a p-attribute.
#' @rdname cl_rework
#' @export
s_attr_size <- function(s_attr) {
    .Call(`_RcppCWB_s_attr_size`, s_attr)
}

#' @rdname cl_rework
#' @export
p_attr_lexicon_size <- function(p_attr) {
    .Call(`_RcppCWB_p_attr_lexicon_size`, p_attr)
}

.cl_lexicon_size <- function(corpus, p_attribute, registry) {
    .Call(`_RcppCWB__cl_lexicon_size`, corpus, p_attribute, registry)
}

.cl_cpos2struc <- function(corpus, s_attribute, cpos, registry) {
    .Call(`_RcppCWB__cl_cpos2struc`, corpus, s_attribute, cpos, registry)
}

#' @param cpos An `integer` vector of corpus positions.
#' @rdname cl_rework
#' @export
cpos_to_struc <- function(s_attr, cpos) {
    .Call(`_RcppCWB_cpos_to_struc`, s_attr, cpos)
}

#' Rcpp wrappers for CWB Corpus Library functions
#' 
#' @param corpus The ID of a CWB corpus.
#' @param p_attribute A positional attribute.
#' @param registry Path to the corpus registry.
#' @param cpos An integer vector of corpus positions.
#' @rdname cl_functions
cpos2str <- function(corpus, p_attribute, registry, cpos) {
    .Call(`_RcppCWB_cpos2str`, corpus, p_attribute, registry, cpos)
}

#' @rdname cl_rework
#' @export
cpos_to_str <- function(p_attr, cpos) {
    .Call(`_RcppCWB_cpos_to_str`, p_attr, cpos)
}

#' @rdname cl_functions
cpos2id <- function(corpus, p_attribute, registry, cpos) {
    .Call(`_RcppCWB_cpos2id`, corpus, p_attribute, registry, cpos)
}

#' @rdname cl_rework
#' @export
cpos_to_id <- function(p_attr, cpos) {
    .Call(`_RcppCWB_cpos_to_id`, p_attr, cpos)
}

#' @param s_attribute A structural attribute.
#' @param struc An integer value with struc.
#' @rdname cl_functions
struc2cpos <- function(corpus, s_attribute, registry, struc) {
    .Call(`_RcppCWB_struc2cpos`, corpus, s_attribute, registry, struc)
}

#' @param struc A length-one `integer` vector with a struc.
#' @rdname cl_rework
#' @export
struc_to_cpos <- function(s_attr, struc) {
    .Call(`_RcppCWB_struc_to_cpos`, s_attr, struc)
}

#' @param id An `integer` vector with token ids.
#' @rdname cl_functions
id2str <- function(corpus, p_attribute, registry, id) {
    .Call(`_RcppCWB_id2str`, corpus, p_attribute, registry, id)
}

.cl_struc2str <- function(corpus, s_attribute, struc, registry) {
    .Call(`_RcppCWB__cl_struc2str`, corpus, s_attribute, struc, registry)
}

#' @rdname cl_rework
#' @export
struc_to_str <- function(s_attr, struc) {
    .Call(`_RcppCWB_struc_to_str`, s_attr, struc)
}

.cl_regex2id <- function(corpus, p_attribute, regex, registry) {
    .Call(`_RcppCWB__cl_regex2id`, corpus, p_attribute, regex, registry)
}

#' @param regex A regular expression.
#' @rdname cl_rework
#' @export
regex_to_id <- function(p_attr, regex) {
    .Call(`_RcppCWB_regex_to_id`, p_attr, regex)
}

.cl_str2id <- function(corpus, p_attribute, str, registry) {
    .Call(`_RcppCWB__cl_str2id`, corpus, p_attribute, str, registry)
}

#' @param str A `character` vector.
#' @rdname cl_rework
#' @export
str_to_id <- function(p_attr, str) {
    .Call(`_RcppCWB_str_to_id`, p_attr, str)
}

.cl_id2freq <- function(corpus, p_attribute, id, registry) {
    .Call(`_RcppCWB__cl_id2freq`, corpus, p_attribute, id, registry)
}

#' @param id An `integer` vector with token ids.
#' @rdname cl_rework
#' @export
id_to_freq <- function(p_attr, id) {
    .Call(`_RcppCWB_id_to_freq`, p_attr, id)
}

.cl_id2cpos <- function(corpus, p_attribute, id, registry) {
    .Call(`_RcppCWB__cl_id2cpos`, corpus, p_attribute, id, registry)
}

#' @rdname cl_rework
#' @export
id_to_cpos <- function(p_attr, id) {
    .Call(`_RcppCWB_id_to_cpos`, p_attr, id)
}

#' @rdname s_attributes
cl_cpos2lbound <- function(corpus, s_attribute, cpos, registry = NULL) {
    .Call(`_RcppCWB_cl_cpos2lbound`, corpus, s_attribute, cpos, registry)
}

#' @rdname cl_rework
#' @export
cpos_to_lbound <- function(s_attr, cpos) {
    .Call(`_RcppCWB_cpos_to_lbound`, s_attr, cpos)
}

#' @rdname s_attributes
#' @details `cl_cpos2rbound()` and `cl_cpos2lbound()` return `NA` for values of
#'   cpos that are outside a struc for the structural attribute given.
cl_cpos2rbound <- function(corpus, s_attribute, cpos, registry = NULL) {
    .Call(`_RcppCWB_cl_cpos2rbound`, corpus, s_attribute, cpos, registry)
}

#' @rdname cl_rework
#' @export
cpos_to_rbound <- function(s_attr, cpos) {
    .Call(`_RcppCWB_cpos_to_rbound`, s_attr, cpos)
}

.cl_find_corpus <- function(corpus, registry) {
    .Call(`_RcppCWB__cl_find_corpus`, corpus, registry)
}

.cl_new_attribute <- function(corpus_pointer, s_attribute, type) {
    .Call(`_RcppCWB__cl_new_attribute`, corpus_pointer, s_attribute, type)
}

.cl_delete_corpus <- function(corpus, registry) {
    .Call(`_RcppCWB__cl_delete_corpus`, corpus, registry)
}

.corpus_is_loaded <- function(corpus, registry) {
    .Call(`_RcppCWB__corpus_is_loaded`, corpus, registry)
}

.cl_charset_name <- function(corpus, registry) {
    .Call(`_RcppCWB__cl_charset_name`, corpus, registry)
}

.cl_struc_values <- function(corpus, s_attribute, registry) {
    .Call(`_RcppCWB__cl_struc_values`, corpus, s_attribute, registry)
}

.corpus_data_dir <- function(corpus, registry) {
    .Call(`_RcppCWB__corpus_data_dir`, corpus, registry)
}

.corpus_info_file <- function(corpus, registry) {
    .Call(`_RcppCWB__corpus_info_file`, corpus, registry)
}

.corpus_full_name <- function(corpus, registry) {
    .Call(`_RcppCWB__corpus_full_name`, corpus, registry)
}

.corpus_p_attributes <- function(corpus, registry) {
    .Call(`_RcppCWB_corpus_p_attributes`, corpus, registry)
}

.corpus_s_attributes <- function(corpus, registry) {
    .Call(`_RcppCWB_corpus_s_attributes`, corpus, registry)
}

.corpus_properties <- function(corpus, registry) {
    .Call(`_RcppCWB_corpus_properties`, corpus, registry)
}

.corpus_property <- function(corpus, registry, property) {
    .Call(`_RcppCWB_corpus_property`, corpus, registry, property)
}

.cl_load_corpus <- function(corpus, registry) {
    .Call(`_RcppCWB_cl_load_corpus`, corpus, registry)
}

.cl_list_corpora <- function() {
    .Call(`_RcppCWB_cl_list_corpora`)
}

.corpus_registry_dir <- function(corpus) {
    .Call(`_RcppCWB_corpus_registry_dir`, corpus)
}

.init_cqp <- function() {
    invisible(.Call(`_RcppCWB_init_cqp`))
}

.cqp_verbosity <- function(quietly, verbose) {
    invisible(.Call(`_RcppCWB_cqp_verbosity`, quietly, verbose))
}

.cqp_get_registry <- function() {
    .Call(`_RcppCWB_cqp_get_registry`)
}

.cqp_get_status <- function() {
    .Call(`_RcppCWB_cqp_get_status`)
}

.cqp_set_registry <- function(registry_dir) {
    .Call(`_RcppCWB_cqp_set_registry`, registry_dir)
}

.cqp_list_corpora <- function() {
    .Call(`_RcppCWB_cqp_list_corpora`)
}

.cqp_query <- function(corpus, subcorpus, query) {
    .Call(`_RcppCWB_cqp_query`, corpus, subcorpus, query)
}

.cqp_subcorpus_size <- function(scorpus) {
    .Call(`_RcppCWB_cqp_subcorpus_size`, scorpus)
}

.cqp_list_subcorpora <- function(inCorpus) {
    .Call(`_RcppCWB_cqp_list_subcorpora`, inCorpus)
}

.cqp_dump_subcorpus <- function(inSubcorpus) {
    .Call(`_RcppCWB_cqp_dump_subcorpus`, inSubcorpus)
}

.cqp_subcorpus_regions <- function(subcorpus) {
    .Call(`_RcppCWB_cqp_subcorpus_regions`, subcorpus)
}

.cqp_drop_subcorpus <- function(inSubcorpus) {
    .Call(`_RcppCWB_cqp_drop_subcorpus`, inSubcorpus)
}

.check_corpus <- function(corpus) {
    .Call(`_RcppCWB_check_corpus`, corpus)
}

.cqp_load_corpus <- function(corpus, registry) {
    .Call(`_RcppCWB_cqp_load_corpus`, corpus, registry)
}

.region_matrix_to_subcorpus <- function(region_matrix, corpus, subcorpus) {
    .Call(`_RcppCWB_region_matrix_to_subcorpus`, region_matrix, corpus, subcorpus)
}

.cwb_makeall <- function(x, registry_dir, p_attribute) {
    .Call(`_RcppCWB_cwb_makeall`, x, registry_dir, p_attribute)
}

.cwb_huffcode <- function(x, registry_dir, p_attribute) {
    .Call(`_RcppCWB_cwb_huffcode`, x, registry_dir, p_attribute)
}

.cwb_compress_rdx <- function(x, registry_dir, p_attribute) {
    .Call(`_RcppCWB_cwb_compress_rdx`, x, registry_dir, p_attribute)
}

.cwb_encode <- function(regfile, data_dir, vrt_dir, encoding, p_attributes, s_attributes_anno, s_attributes_noanno, skip_blank_lines, strip_whitespace, xml, quiet, verbosity) {
    .Call(`_RcppCWB_cwb_encode`, regfile, data_dir, vrt_dir, encoding, p_attributes, s_attributes_anno, s_attributes_noanno, skip_blank_lines, strip_whitespace, xml, quiet, verbosity)
}

# Register entry points for exported C++ functions
methods::setLoadAction(function(ns) {
    .Call(`_RcppCWB_RcppExport_registerCCallable`)
})
